import ResponseFactory from './ResponseFactory.ts'
import ViewEngine from '../../unit/ViewEngine.ts'
import {Request} from '../Request.ts'

export default class PartialViewResponseFactory extends ResponseFactory {
    constructor(
        public readonly view: string,
        public readonly context?: any,
    ) {
        super()
    }

    public async write(request: Request) {
        const views: ViewEngine = this.make(ViewEngine)
        request.response.body = await views.partial(this.view, this.context)
        return request
    }
}
