import {QueryRow} from '../../../db/types.ts'
import ConnectionExecutable from '../ConnectionExecutable.ts'
import {Model} from '../../../model/Model.ts'
import {Collection} from '../../../../../lib/src/collection/Collection.ts'

export default abstract class ResultOperator<T> {
    public async process_eager_loads<T2>(query: ConnectionExecutable<T2>, results: Collection<T>): Promise<void> { }

    abstract inflate_row(row: QueryRow): T
    abstract deflate_row(item: T): QueryRow
}
